import React, { Component } from "react";
import ContentWrapper from "@/components/Layout/ContentWrapper";
import { Row, Col, Button } from "reactstrap";
import { getPelaporan } from "@/actions/pelaporan";
import { getGraph, getExcel } from "@/actions/graph";
import CaseProgress from "@/components/Delegasi/CaseProgress";
import TableLaporan from "@/components/Main/TableLaporan";
import { connect } from "react-redux";
import Loader from "@/components/Common/Loader";
import Router from "next/router";
import { createLog } from "@/actions/log";

class Pelaporan extends Component {
	constructor(props) {
		super(props);
		this.state = {
			pelaporan: {},
			graph: {},
			tahun: new Date().getFullYear(),
		};
	}

	componentDidMount = async () => {
		const { token } = this.props;
		await createLog(token, { aktivitas: "Mengakses halaman Laporan Delegasi", menu: "Laporan Delegasi" });
		const pelaporan = await getPelaporan(this.props.token, { delegasi: true });
		const graph = await getGraph(this.props.token, { jumlahLaporan: true });
		this.setState({ pelaporan, graph });
	};

	nextButton = async () => {
		const tahun = this.state.tahun + 1;
		const graph = await getGraph(this.props.token, { jumlahLaporan: true, tahun });
		this.setState({ graph, tahun });
	};

	prevButton = async () => {
		const tahun = this.state.tahun - 1;
		const graph = await getGraph(this.props.token, { jumlahLaporan: true, tahun });
		this.setState({ graph, tahun });
	};

	shouldComponentUpdate = (prevProps, prevState) => {
		if (prevState.graph !== this.state.graph) return true;
	};

	excel = () => {
		const url = getExcel(this.props.token, "Laporan Delegasi", { tahun: this.state.tahun });
		Router.push(url);
	};

	render() {
		const { pelaporan, graph } = this.state;
		return (
			<ContentWrapper>
				<div className="content-heading">
					<div className="font-color-white">Laporan Delegasi</div>
				</div>
				<Row>
					<Col lg="4">{graph?.data ? <CaseProgress data={graph.data} nextButton={this.nextButton} prevButton={this.prevButton} tahun={this.state.tahun} excel={this.excel} /> : <Loader />}</Col>
					<Col lg="8">{pelaporan?.data ? <TableLaporan listData={pelaporan.data} to="/app/laporan-delegasi/detail" linkName="Detail" /> : <Loader />}</Col>
				</Row>
			</ContentWrapper>
		);
	}
}

const mapStateToProps = (state) => ({ user: state.user, token: state.token });
export default connect(mapStateToProps)(Pelaporan);
